;TT v2.0

;#################
;# System Module #
;#################

alias ttversion {

  ;Syntax: $ttversion

  return 2.0
}

alias ttconf {

  ;Syntax: $ttconf(section,item)

  return $readini($scriptdir $+ ttconf.ini,$1,$2)
}

;##############
;# Dcx Module #
;##############

alias dcx { if ($isid) { return $dll($scriptdirdll\dcx.dll,$1,$2-) } | else { dll " $+ $scriptdirdll\dcx.dll" $1 $2- } }
alias udcx { if ($dcx(IsUnloadSafe)) { $iif($menu, .timer 1 0) dll -u dcx.dll } | else { echo 4 -qmlbfti2 [DCX] Unable to Unload Dll. } }
alias xdid { if ($isid) { return $dcx( _xdid, $1 $2 $prop $3- ) } | dcx xdid $2 $3 $1 $4- }
alias xdialog { if ($isid) { return $dcx( _xdialog, $1 $prop $2- ) } | dcx xdialog $2 $1 $3- }

;alias xpopup { if ( $isid ) return $dcx( _xpopup, $1 $prop $2- ) | dcx xpopup $2 $1 $3- }
;alias xpop { if ( $isid ) return $dcx( _xpop, $1 $prop $2- ) | dcx xpop $2 $1 $3- }

;##################
;# Dialogs Module #
;##################

alias tt {
  if ($1 isnum) { set %ttguilanguage $1 }
  if ($dialog(ttupdater)) { return }
  if ($dialog(tt)) { dialog -x tt }
  if (%ttinitcheck) { ttupdater clean | ttupdater download ttconf.ini | ttupdater start }
  else { dialog -m tt tt }
}

dialog tt {
  title "Thug's Tools for mIRC"
  size -1 -1 440 382
  option pixel

  menu "", 30
  item , 31, 30
  menu , 32, 30
  item , 33, 32
  item , 34, 32
  item , 35, 32
  item , 36, 32
  item , 37, 32
  item , 38, 32
  item , 39, 32
}

alias ttupdategui {
  var %dname = tt
  var %gui = gui [ $+ [ %ttguilanguage ] ]

  did -o %dname 30 $ttconf(%gui,menu_options)
  did -o %dname 31 $ttconf(%gui,menu_options_initcheck)
  did $iif(%ttinitcheck,-c,-u) %dname 31
  did -o %dname 32 $ttconf(%gui,menu_options_guilanguage)

  var %i = 1
  while (%i <= 7) {
    var %id = $calc(32 + %i)
    if (%i <= $ttconf(gui,n)) {
      did -eou %dname %id $ttconf(gui $+ %i,code) - $ttconf(gui $+ %i,name)
      if (%ttguilanguage == %i) { did -c %dname %id }
    }
    else { did -obu %dname %id - }
    inc %i
  }

  xdid -t %dname 1 $ttconf(%gui,button_update)
  xdid -t %dname 2 $ttconf(%gui,button_site)
  xdid -t %dname 3 $ttconf(%gui,button_help)
  xdid -t %dname 4 $ttconf(%gui,button_details)

  dialog -s %dname -1 -1 $iif(%ttguidetails,640,440) 402

  xdid -l %dname 4 16
  xdid -w %dname 4 -n 0 $scriptdir $+ icons\ $+ $iif($dialog(%dname).w > 600,left.ico,right.ico)

  xdid -t %dname 11 $ttconf(%gui,text_filter)
  xdid -t %dname 12 $ttconf(%gui,text_filter_language)
  xdid -t %dname 14 $ttconf(%gui,text_filter_category)

  xdid -r %dname 13
  xdid -a %dname 13 0 0 0 0 0 $ttconf(%gui,combo_language_all)
  var %i = 1
  while (%i <= $ttconf(languages,n)) {
    var %l = language [ $+ [ %i ] ]
    xdid -a %dname 13 0 0 0 0 0 $ttconf(%l,code) - $ttconf(%l,name)
    inc %i
  }
  xdid -c %dname 13 1

  var %name = name [ $+ [ %ttguilanguage ] ]
  xdid -r %dname 15
  xdid -a %dname 15 0 0 0 0 0 $ttconf(%gui,combo_category_all)
  var %i = 1
  while (%i <= $ttconf(categories,n)) {
    xdid -a %dname 15 0 0 0 0 0 $ttconf(category [ $+ [ %i ] ],%name)
    inc %i
  }
  xdid -c %dname 15 1

  xdid -t %dname 21 +l 0 130 $ttconf(%gui,listview_header_installed) $chr(9) +l 0 115 $ttconf(%gui,listview_header_category) $chr(9) +l 0 79 $ttconf(%gui,listview_header_version) $chr(9) +l 0 85 $ttconf(%gui,listview_header_language) $chr(9) +l 0 0 $ttconf(%gui,listview_header_number)

  xdid -t %dname 40 $ttconf(%gui,button_install)

  ttupdatelist
}

alias ttupdatelist {
  var %dname = tt
  var %newbgcolor = $rgb(200,255,180)
  xdid -r %dname 21

  var %filterlanguage = $calc($xdid(%dname,13).sel - 1)
  var %filtercategory = $calc($xdid(%dname,15).sel - 1)

  var %i = 1
  while (%i <= $ttconf(snippets,n)) {
    var %snippet = snippet [ $+ [ %i ] ]

    if ((%filterlanguage != 0) && ($ttconf(%snippet,language) != $null) && ($ttconf(%snippet,language) != %filterlanguage)) { inc %i | continue }
    if ((%filtercategory != 0) && ($ttconf(%snippet,category) != %filtercategory)) { inc %i | continue }

    if ($group(#tt- [ $+ [ %i ] ])) { xdid -a %dname 21 0 0 +ck 0 2 0 0 -1 -1 $ttconf(%snippet,name) $chr(9) + 0 $ttconf(category [ $+ [ $ttconf(%snippet,category) ] ],name [ $+ [ %ttguilanguage ] ]) $chr(9) + 0 $ttconf(%snippet,version) $chr(9) + 0 $ttconf(language [ $+ [ $ttconf(%snippet,language) ] ],code) $chr(9) + 0 %i }
    else {
      if (($ttconf(%snippet,enabled)) && ($ttconf(%snippet,latest) == %i)) {
        var %previous = $false
        var %n = 1
        while (%n <= $numtok($ttconf(%snippet,previousversions),44)) {
          if ($group(tt- [ $+ [ $gettok($ttconf(%snippet,previousversions),1,44) ] ])) { var %previous = $true }
          inc %n
        }
        xdid -a %dname 21 0 0 + $+ $iif(%previous,b) $+ ck 0 1 0 0 -1 $iif(%ttrelease <= $ttconf(%snippet,release),%newbgcolor,-1) $ttconf(%snippet,name) $chr(9) + 0 $ttconf(category [ $+ [ $ttconf(%snippet,category) ] ],name [ $+ [ %ttguilanguage ] ]) $chr(9) + 0 $ttconf(%snippet,version) $chr(9) + 0 $ttconf(language [ $+ [ $ttconf(%snippet,language) ] ],code) $chr(9) + 0 %i
      }
    }
    inc %i
  }

  xdid -z %dname 21 + 1
  xdid -c %dname 21 1
  ttupdatedetails
}

alias ttupdatedetails {
  var %dname = tt
  xdid -r %dname 50
  if ($xdid(%dname,21).selnum) {
    var %gui = gui [ $+ [ %ttguilanguage ] ]
    var %snippet = snippet [ $+ [ $xdid(%dname,21,4).seltext ] ]
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_name) $+  $ttconf(%snippet,name) $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_type) $+  $ttconf(%snippet,type) $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_version) $+  $ttconf(%snippet,version) $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_language) $+  $ttconf(language [ $+ [ $ttconf(%snippet,language) ] ],code) $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_category) $+  $ttconf(category [ $+ [ $ttconf(%snippet,category) ] ],name [ $+ [ %ttguilanguage ] ]) $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_author) $+  $ttconf(%snippet,author)  $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_date) $+  $ttconf(%snippet,date) $crlf $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_description) $+  $ttconf(%snippet,description) $crlf $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_syntax) $+  $ttconf(%snippet,syntax) $crlf $crlf
    var %i = 1 | while (%i <= $numtok($ttconf(%snippet,dependencies),44)) { var %dependencies = $addtok(%dependencies,$ttconf(snippet [ $+ [ $gettok($ttconf(%snippet,dependencies),%i,44) ] ],name) v $+ $ttconf(snippet [ $+ [ $gettok($ttconf(%snippet,dependencies),%i,44) ] ],version),44) | inc %i }
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_dependencies) $+  %dependencies $crlf
    var %i = 1 | while (%i <= $numtok($ttconf(%snippet,conflicts),44)) { var %conflicts = $addtok(%conflicts,$ttconf(snippet [ $+ [ $gettok($ttconf(%snippet,conflicts),%i,44) ] ],name),44) v $+ $ttconf(snippet [ $+ [ $gettok($ttconf(%snippet,conflicts),%i,44) ] ],version),44) | inc %i }
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_conflicts) $+  %conflicts $crlf $crlf
    xdid -a %dname 50  $+ $ttconf(%gui,details_text_manual) $+  $ttconf(%snippet,manual)
  }
}

on *:dialog:tt:*:*:{
  if ($devent == init) {

    if (%ttguilanguage == $null) { set %ttguilanguage 1 }
    if (%ttinitcheck == $null) { set %ttinitcheck 1 }
    ttupdater clean

    dialog -t $dname Thug's Tools for mIRC v $+ $ttversion
    dcx Mark $dname tt_dcx_event
    xdialog -w $dname + 0 $scriptdir $+ icons\tt.ico
    xdialog -c $dname 1 button 5 5 80 22
    xdid -w $dname 1 -n 0 $scriptdir $+ icons\tt.ico
    xdialog -c $dname 2 button 90 5 80 22
    xdid -w $dname 2 -n 0 $scriptdir $+ icons\site.ico
    xdialog -c $dname 3 button 175 5 80 22
    xdid -w $dname 3 -n 0 $scriptdir $+ icons\help.ico
    xdialog -c $dname 4 button 355 5 80 22
    xdid -w $dname 4 -n 0 $scriptdir $+ icons\right.ico
    xdialog -c $dname 10 line 6 32 431 1
    xdialog -c $dname 11 text 5 42 90 22 center endellipsis
    xdialog -c $dname 12 text 100 42 60 22 right endellipsis
    xdialog -c $dname 13 comboex 165 38 100 200 dropdown
    xdialog -c $dname 14 text 270 42 60 22 right endellipsis
    xdialog -c $dname 15 comboex 335 38 100 200 dropdown
    xdialog -c $dname 20 line 6 65 431 1
    xdialog -c $dname 21 listview 5 70 430 280 report checkbox fullrow showsel singlesel
    xdialog -c $dname 40 button 355 355 80 22
    xdid -w $dname 40 -n 0 $scriptdir $+ icons\install.ico
    xdialog -c $dname 50 richedit 442 5 192 370 multi readonly
    xdid -f $dname 50 + ansi 8 Verdana
    xdid -n $dname 50 1
    ttupdategui
    return
  }

  if ($did == 31) { did $iif($did(31).state,-u,-c) $dname 31 | set %ttinitcheck $did(31).state | return }
  if ($did isnum 33-39) {
    if ($did == $calc(%ttguilanguage + 32)) { return }
    did -u $dname $calc(%ttguilanguage + 32) | did -c $dname $did
    set %ttguilanguage $calc($did - 32) | ttupdategui | return
  }

}

alias tt_dcx_event {
  var %dname = tt

  if (($3 == 21) && (($2 == sclick) || ($2 == begindrag))) { ttupdatedetails }
  elseif ($2 == sclick) {
    if ($3 == 1) { ttupdater clean | ttupdater download ttconf.ini | ttupdater start }
    elseif ($3 == 2) { url -an http://www.ptscripting.com }
    elseif ($3 == 3) { url -an http://oakws.dyndns.org/thugstools/2.0/docs/index.php }
    elseif ($3 == 4) {
      dialog -s %dname $dialog(%dname).x $dialog(%dname).y $iif($dialog(%dname).w < 600,640,440) 402
      xdid -l %dname 4 16 | xdid -w %dname 4 -n 0 $scriptdir $+ icons\ $+ $iif($dialog(%dname).w > 600,left.ico,right.ico)
      set %ttguidetails $iif($dialog(%dname).w < 600,0,1)
    }
    elseif (($3 == 13) || ($3 == 15)) { ttupdatelist | xdid -F %dname 21 }
    elseif ($3 == 50) { url -a $ttconf(snippet [ $+ [ $xdid(%dname,21,4).seltext ] ],manual) | xdid -F %dname 21 }
    elseif ($3 == 40) {
      var %i = 1
      while (%i <= $numtok($hget(ttupdater,tempinstall),44)) {
        ttupdater download snippet- $+ $gettok($hget(ttupdater,tempinstall),%i,44) $+ .mrc
        ttupdater install $gettok($hget(ttupdater,tempinstall),%i,44)
        inc %i
      }
      var %i = 1
      while (%i <= $numtok($hget(ttupdater,tempremove),44)) {
        ttupdater remove $gettok($hget(ttupdater,tempremove),%i,44)
        inc %i
      }
      set %ttupdatecancel 0
      .timer 1 0 ttupdater start
    }
  }
  elseif ($3 == 21) {
    if ($2 == hsclick) { xdid -z %dname 21 + $4 }
    elseif ($2 == stateclick) {
      if ($xdid(%dname,$3,$4).state == 1) { ttchecksnippet $4 $xdid(%dname,$3,$4,4).text }
      else { ttunchecksnippet $4 $xdid(%dname,$3,$4,4).text }
    }
  }
}

dialog ttupdater {
  title "TT Updater"
  size -1 -1 265 150
  option pixel
}

on *:dialog:ttupdater:*:*:{
  if ($devent == init) {
    dcx Mark $dname ttupd_dcx_event
    xdialog -w $dname + 0 $scriptdir $+ icons\tt.ico

    xdialog -c $dname 1 text 10 8 245 15 endellipsis nowrap pathellipsis
    xdialog -c $dname 2 pbar 10 25 245 20
    xdialog -c $dname 3 text 10 55 245 15 endellipsis nowrap pathellipsis
    xdialog -c $dname 4 pbar 10 72 245 20
    xdialog -c $dname 5 button 80 110 105 30
    xdid -w $dname 5 -n 0 $scriptdir $+ icons\remove.ico
    xdid -t $dname 5 $ttconf(gui [ $+ [ %ttguilanguage ] ],button_upd_cancel)
  }
}

alias ttupd_dcx_event {
  var %dname = tt
  if (($2 == sclick) && ($3 == 5)) { set %ttupdatecancel 1 | .signal -n ttupdater-cancel }
}

;#################
;# Errors Module #
;#################

alias tterror {

  ;Syntax: /tterror [COMMAND] [ERROR_MSG]

  linesep | echo $color(info text) -s * $iif($1 == $null,Unknown error!,$1) $+ $iif($2 != $null,: $2-) | linesep
  halt
}

;#################
;# System Module #
;#################

on *:load:{
  echo -a Loaded Thug's Tools for mIRC v $+ $ttversion by PTScripting Team 
  echo -a Channel: #PTScripting @ PTnet - Website: www.PTScripting.com
  url -n http://oakws.dyndns.org/thugstools/2.0/docs/index.php
  tt
}

menu status,menubar {
  TT:tt
}

alias ttchecksnippet {

  ;Syntax: /ttchecksnippet <ID> <snippet_num>

  var %dname = tt
  var %gui = gui [ $+ [ %ttguilanguage ] ]
  var %snippet = snippet [ $+ [ $2 ] ]

  var %conflicts = $ttconf(%snippet,conflicts)
  var %dependencies = $ttconf(%snippet,dependencies)

  var %i = 1
  while (%i <= $numtok(%conflicts,44)) {
    if (($istok($hget(ttupdater,tempinstall),$gettok(%conflicts,%i,44),44)) || ((($group(#tt- [ $+ [ $gettok(%conflicts,%i,44) ] ]))) && (!$istok($hget(ttupdater,tempremove),$gettok(%conflicts,%i,44),44)))) { var %conflicts2 = $addtok(%conflicts2,$ttconf(snippet [ $+ [ $gettok(%conflicts,%i,44) ] ],name),44) | var %conflicts3 = $addtok(%conflicts3,$gettok(%conflicts,%i,44),44) }
    inc %i
  }
  var %i = 1
  while (%i <= $numtok(%dependencies,44)) {
    if (($istok($hget(ttupdater,tempremove),$gettok(%dependencies,%i,44),44)) || (((!$group(#tt- [ $+ [ $gettok(%dependencies,%i,44) ] ]))) && (!$istok($hget(ttupdater,tempinstall),$gettok(%dependencies,%i,44),44)))) { var %dependencies2 = $addtok(%dependencies2,$ttconf(snippet [ $+ [ $gettok(%dependencies,%i,44) ] ],name),44) | var %dependencies3 = $addtok(%dependencies3,$gettok(%dependencies,%i,44),44) }
    inc %i
  }

  if (($numtok(%conflicts3,44)) || ($numtok(%dependencies3,44))) {
    if ($input($ttconf(%snippet,name) $+ $crlf $+ $crlf $+ $ttconf(%gui,check_text_conflicts) $+ $crlf $+ $replace(%conflicts2,$chr(44),$crlf) $+ $crlf $+ $crlf $+ $ttconf(%gui,check_text_dependencies) $+ $crlf $+ $replace(%dependencies2,$chr(44),$crlf) $+ $crlf $+ $crlf $+ $ttconf(%gui,check_text_question1),yqdau,$ttconf(%gui,check_text_title1))) {

      var %i = 1
      while (%i <= $numtok(%conflicts,44)) {
        if ($istok($hget(ttupdater,tempinstall),$gettok(%conflicts,%i,44),44)) { hadd ttupdater tempinstall $remtok($hget(ttupdater,tempinstall),$gettok(%conflicts,%i,44),1,44) }
        else { hadd ttupdater tempremove $addtok($hget(ttupdater,tempremove),$gettok(%conflicts,%i,44),44) }
        inc %i
      }

      var %i = 1
      while (%i <= $numtok(%dependencies,44)) {
        if ($istok($hget(ttupdater,tempremove),$gettok(%dependencies,%i,44),44)) { hadd ttupdater tempremove $remtok($hget(ttupdater,tempremove),$gettok(%dependencies,%i,44),1,44) }
        else { hadd ttupdater tempinstall $addtok($hget(ttupdater,tempinstall),$gettok(%dependencies,%i,44),44) }
        inc %i
      }

      if ($istok($hget(ttupdater,tempremove),$2,44)) { hadd ttupdater tempremove $remtok($hget(ttupdater,tempremove),$2,1,44) }
      else { hadd ttupdater tempinstall $addtok($hget(ttupdater,tempinstall),$2,44) }

      var %i = 1
      while (%i <= $xdid(%dname,21).num) {
        if ($1 != %i) {
          if (($istok($hget(ttupdater,tempremove),$xdid(%dname,21,%i,4).text,44)) || ((!$group(#tt- [ $+ [ $xdid(%dname,21,%i,4).text ] ])) && (!$istok($hget(ttupdater,tempinstall),$xdid(%dname,21,%i,4).text,44)))) { xdid -k %dname 21 1 %i }
          else { xdid -k %dname 21 2 %i }
        }
        inc %i
      }
    }
    else { .timer 1 0 xdid -k %dname 21 1 $1 }
  }
  else {
    if ($istok($hget(ttupdater,tempremove),$2,44)) { hadd ttupdater tempremove $remtok($hget(ttupdater,tempremove),$2,1,44) }
    else { hadd ttupdater tempinstall $addtok($hget(ttupdater,tempinstall),$2,44) }
  }
}

alias ttunchecksnippet {

  ;Syntax: /ttunchecksnippet <ID> <snippet_num>

  var %dname = tt
  var %gui = gui [ $+ [ %ttguilanguage ] ]
  var %snippet = snippet [ $+ [ $2 ] ]

  var %dependants = $ttconf(%snippet,dependant)

  var %i = 1
  while (%i <= $numtok(%dependants,44)) {
    if (($istok($hget(ttupdater,tempinstall),$gettok(%dependants,%i,44),44)) || ((($group(#tt- [ $+ [ $gettok(%dependants,%i,44) ] ]))) && (!$istok($hget(ttupdater,tempremove),$gettok(%dependants,%i,44),44)))) { var %dependants2 = $addtok(%dependants2,$ttconf(snippet [ $+ [ $gettok(%dependants,%i,44) ] ],name),44) | var %dependants3 = $addtok(%dependants3,$gettok(%dependants,%i,44),44) }
    inc %i
  }

  if ($numtok(%dependants3,44)) {
    if ($input($ttconf(%snippet,name) $+ $crlf $+ $crlf $+ $ttconf(%gui,check_text_dependants) $+ $crlf $+ $replace(%dependants2,$chr(44),$crlf) $+ $crlf $+ $crlf $+ $ttconf(%gui,check_text_question2),yqdau,$ttconf(%gui,check_text_title2))) {

      var %i = 1
      while (%i <= $numtok(%dependants,44)) {
        if ($istok($hget(ttupdater,tempinstall),$gettok(%dependants,%i,44),44)) { hadd ttupdater tempinstall $remtok($hget(ttupdater,tempinstall),$gettok(%dependants,%i,44),1,44) }
        else { hadd ttupdater tempremove $addtok($hget(ttupdater,tempremove),$gettok(%dependants,%i,44),44) }
        inc %i
      }

      if ($istok($hget(ttupdater,tempinstall),$2,44)) { hadd ttupdater tempinstall $remtok($hget(ttupdater,tempinstall),$2,1,44) }
      else { hadd ttupdater tempremove $addtok($hget(ttupdater,tempremove),$2,44) }

      var %i = 1
      while (%i <= $xdid(%dname,21).num) {
        if ($1 != %i) {
          if (($istok($hget(ttupdater,tempremove),$xdid(%dname,21,%i,4).text,44)) || ((!$group(#tt- [ $+ [ $xdid(%dname,21,%i,4).text ] ])) && (!$istok($hget(ttupdater,tempinstall),$xdid(%dname,21,%i,4).text,44)))) { xdid -k %dname 21 1 %i }
          else { xdid -k %dname 21 2 %i }
        }
        inc %i
      }
    }
    else { .timer 1 0 xdid -k %dname 21 2 $1 }
  }
  else {
    if ($istok($hget(ttupdater,tempinstall),$2,44)) { hadd ttupdater tempinstall $remtok($hget(ttupdater,tempinstall),$2,1,44) }
    else { hadd ttupdater tempremove $addtok($hget(ttupdater,tempremove),$2,44) }
  }
}

alias ttupdater {

  ;Syntax: /ttupdater <clean|download|remove|install|start> <snippet1> [snippet2] [snippet3] [...]

  var %dname = ttupdater

  if (!$hget(ttupdater)) { hmake ttupdater }
  if ($1 == clean) { hfree ttupdater | unset %ttupdaterstep | hmake ttupdater }
  elseif ($1 == download) { hadd ttupdater download $addtok($hget(ttupdater,download),$2-,32) }
  elseif ($1 == remove) { hadd ttupdater remove $addtok($hget(ttupdater,remove),$2-,32) }
  elseif ($1 == install) { hadd ttupdater install $addtok($hget(ttupdater,install),$2-,32) }
  elseif ($1 == start) {
    hadd ttupdater total 0
    hadd ttupdater downloadcurrent $hget(ttupdater,download)
    hadd ttupdater removecurrent $hget(ttupdater,remove)
    hadd ttupdater installcurrent $hget(ttupdater,install)
    if ($hget(ttupdater,install) != $null) { set %ttupdaterstep 3 | hinc ttupdater total }
    if ($hget(ttupdater,remove) != $null) { set %ttupdaterstep 2 | hinc ttupdater total }
    if ($hget(ttupdater,download) != $null) { set %ttupdaterstep 1 | hinc ttupdater total }
    if (%ttupdaterstep) {
      if ($dialog(tt)) { dialog -x tt }
      var %dummy = $findfile($scriptdir $+ temp,*,0,.remove $qt($1-))
      if ($dialog(ttupdater)) { dialog -x ttupdater }
      hadd ttupdater current 1
      dialog -mavo ttupdater ttupdater
      var %gui = gui [ $+ [ %ttguilanguage ] ]
      xdid -t %dname 1 $ttconf(%gui,text_upd_ [ $+ [ %ttupdaterstep ] ]) $+ ... ( $+ $hget(ttupdater,current) $+ /  $+ $hget(ttupdater,total) $+ )
      if (%ttupdaterstep == 1) { ttdownload http://oakws.dyndns.org/thugstools/2.0/snippets/ $+ $gettok($hget(ttupdater,downloadcurrent),1,32) $scriptdir $+ temp }
      elseif (%ttupdaterstep == 2) { ttremove $gettok($hget(ttupdater,removecurrent),1,32) }
      elseif (%ttupdaterstep == 3) { ttinstall $gettok($hget(ttupdater,installcurrent),1,32) }
    }
  }
}

on *:signal:*:{
  var %dname = ttupdater
  var %gui = gui [ $+ [ %ttguilanguage ] ]

  if ($signal == ttupdater-cancel) { if ($sock(ttdownload)) { sockclose ttdownload } | .timerttdownload off | ttupdateresult | return }
  if (%ttupdatecancel) { return }

  if (($signal == ttdownload-start) && $dialog(ttupdater)) { xdid -t %dname 3 $ttconf(%gui,text_upd_1) $1- $+ ... ( $+ $calc($numtok($hget(ttupdater,download),32) - $numtok($hget(ttupdater,downloadcurrent),32) + 1) $+ / $+ $numtok($hget(ttupdater,download),32) $+ ) }
  elseif (($signal == ttdownload-progress) && $dialog(ttupdater)) { set %ttdownloadctime $ctime | set %ttdownloadprogress $1 | xdid -v %dname 4 $1 }
  elseif (($signal == ttdownload-finished) || ($signal == ttdownload-sockerr) || ($signal == ttdownload-canceled) || ($signal == ttdownload-notfound)) {
    .timerttdownload off
    if (($signal == ttdownload-sockerr) || ($signal == ttdownload-canceled) || ($signal == ttdownload-notfound)) { hadd ttupdater downloadfailed $addtok($hget(ttupdater,downloadfailed),$1,32) }
    hadd ttupdater downloadcurrent $deltok($hget(ttupdater,downloadcurrent),1,32)
    if ($1 == ttconf.ini) {
      if (%ttrelease != $gettok($ttconf(system,version),3,46)) { set %ttrelease $gettok($ttconf(system,version),3,46) }
      .copy -o $qt($scriptdir $+ temp\ttconf.ini) $qt($scriptdir $+ ttconf.ini)
    }
    if ($dialog(ttupdater)) { xdid -v %dname 2 $calc((($numtok($hget(ttupdater,download),32) - $numtok($hget(ttupdater,downloadcurrent),32)) / $numtok($hget(ttupdater,download),32)) * ($hget(ttupdater,current) / $hget(ttupdater,total)) * 100) }

    if ($numtok($hget(ttupdater,downloadcurrent),32)) { ttdownload http://oakws.dyndns.org/thugstools/2.0/snippets/ $+ $gettok($hget(ttupdater,downloadcurrent),1,32) $scriptdir $+ temp }
    else {
      if ($hget(ttupdater,remove) != $null) {
        set %ttupdaterstep 2
        hinc ttupdater current
        if ($dialog(ttupdater)) {
          xdid -t %dname 1 $ttconf(%gui,text_upd_ [ $+ [ %ttupdaterstep ] ]) $+ ... ( $+ $hget(ttupdater,current) $+ /  $+ $hget(ttupdater,total) $+ )
          xdid -v %dname 2 0
        }
        ttremove $gettok($hget(ttupdater,removecurrent),1,32)
      }
      elseif ($hget(ttupdater,install) != $null) {
        set %ttupdaterstep 3
        hinc ttupdater current
        if ($dialog(ttupdater)) {
          xdid -t %dname 1 $ttconf(%gui,text_upd_ [ $+ [ %ttupdaterstep ] ]) $+ ... ( $+ $hget(ttupdater,current) $+ /  $+ $hget(ttupdater,total) $+ )
          xdid -v %dname 2 0
        }
        ttinstall $gettok($hget(ttupdater,installcurrent),1,32)
      }
      else { ttupdateresult }
    }
  }
  elseif (($signal == ttremove-end) || ($signal == ttremove-notfound)) {
    if ($signal == ttremove-notfound) { hadd ttupdater removefailed $addtok($hget(ttupdater,removefailed),$1,32) }
    hadd ttupdater removecurrent $deltok($hget(ttupdater,removecurrent),1,32)
    if ($dialog(ttupdater)) {
      xdid -v %dname 2 $calc((($numtok($hget(ttupdater,remove),32) - $numtok($hget(ttupdater,removecurrent),32)) / $numtok($hget(ttupdater,remove),32)) * ($hget(ttupdater,current) / $hget(ttupdater,total)) * 100)
      xdid -v %dname 4 100
    }
    if ($numtok($hget(ttupdater,removecurrent),32)) { ttremove $gettok($hget(ttupdater,removecurrent),1,32) }
    else {
      .reload -rs $qt($scriptdir $+ ttsnippets.mrc)
      if ($hget(ttupdater,install) != $null) {
        set %ttupdaterstep 3
        hinc ttupdater current
        if ($dialog(ttupdater)) {
          xdid -t %dname 1 $ttconf(%gui,text_upd_ [ $+ [ %ttupdaterstep ] ]) $+ ... ( $+ $hget(ttupdater,current) $+ /  $+ $hget(ttupdater,total) $+ )
          xdid -v %dname 2 0
        }
        ttinstall $gettok($hget(ttupdater,installcurrent),1,32)
      }
      else { ttupdateresult }
    }
  }
  elseif (($signal == ttremove-start) && ($dialog(ttupdater))) {
    xdid -t %dname 3 $ttconf(%gui,text_upd_2) $ttconf(snippet [ $+ [ $1 ] ],name) $+ ... ( $+ $calc($numtok($hget(ttupdater,remove),32) - $numtok($hget(ttupdater,removecurrent),32) + 1) $+ / $+ $numtok($hget(ttupdater,remove),32) $+ )
    xdid -v %dname 4 0
  }
  elseif (($signal == ttinstall-end) || ($signal == ttinstall-notfound)) {
    if ($signal == ttinstall-notfound) { hadd ttupdater installfailed $addtok($hget(ttupdater,installfailed),$1,32) }
    hadd ttupdater installcurrent $deltok($hget(ttupdater,installcurrent),1,32)
    if ($dialog(ttupdater)) {
      xdid -v %dname 2 $calc((($numtok($hget(ttupdater,install),32) - $numtok($hget(ttupdater,installcurrent),32)) / $numtok($hget(ttupdater,install),32)) * ($hget(ttupdater,current) / $hget(ttupdater,total)) * 100)
      xdid -v %dname 4 100
    }
    if ($numtok($hget(ttupdater,installcurrent),32)) { ttinstall $gettok($hget(ttupdater,installcurrent),1,32) }
    else { .reload -rs $qt($scriptdir $+ ttsnippets.mrc) | ttupdateresult }
  }
  elseif (($signal == ttremove-start) && ($dialog(ttupdater))) {
    xdid -t %dname 3 $ttconf(%gui,text_upd_2) $ttconf(snippet [ $+ [ $1 ] ],name) $+ ... ( $+ $calc($numtok($hget(ttupdater,remove),32) - $numtok($hget(ttupdater,removecurrent),32) + 1) $+ / $+ $numtok($hget(ttupdater,remove),32) $+ )
    xdid -v %dname 4 0
  }
}

alias ttchecktimeout { if ($calc($ctime - %ttdownloadctime) > 5) { .signal -n ttdownload-canceled %ttdownloadfile } }

alias ttupdateresult {
  var %dummy = $findfile($scriptdir $+ temp,*,0,.remove $qt($1-))
  if ($dialog(ttupdater)) { dialog -x ttupdater }
  var %gui = gui [ $+ [ %ttguilanguage ] ]
  if (%ttupdatecancel) { var %dummy = $input($ttconf(%gui,upd_result_text_cancel),owda,$ttconf(%gui,upd_result_title)) }
  elseif (($numtok($hget(ttupdater,downloadfailed),32)) || ($numtok($hget(ttupdater,removefailed),32)) || ($numtok($hget(ttupdater,installfailed),32))) { var %dummy = $input($ttconf(%gui,upd_result_text_ko),owda,$ttconf(%gui,upd_result_title)) }
  else { var %dummy = $input($ttconf(%gui,upd_result_text_ok),oida,$ttconf(%gui,upd_result_title)) }
  if ($dialog(tt)) { dialog -x tt }
  dialog -m tt tt
}

alias ttinstall {

  ;Syntax: /ttinstall <snippet_num>

  if ($1 !isnum) { tterror /ttinstall invalid parameters }

  .signal -n ttinstall-start $1
  var %file = $qt($scriptdir $+ temp\snippet- $+ $1 $+ .mrc)
  var %file2 = $qt($scriptdir $+ ttsnippets.mrc)
  if (!$exists(%file)) { .signal -n ttinstall-notfound $1 | return }
  if ($read(%file2,$lines(%file2)) != $null) { write $qt($scriptdir $+ ttsnippets.mrc) }
  .copy -a %file %file2
  .signal -n ttinstall-end $1
}

alias ttremove {

  ;Syntax: /ttremove <snippet_num>

  if ($1 !isnum) { tterror /ttremove invalid parameters }

  .signal -n ttremove-start $1

  var %file = $qt($scriptdir $+ ttsnippets.mrc)
  var %search = #tt- [ $+ [ $1 ] ] $+ *

  var %dummy = $read(%file,w,%search) | var %start = $readn
  var %dummy = $read(%file,w,%search,$calc(%start + 1)) | var %end = $readn

  if ((%start == 0) || (%end == 0)) { .signal -n ttremove-notfound $1 | return }

  while (%end >= %start) { write -dl [ $+ [ %end ] ] %file | dec %end }
  .signal -n ttremove-end $1  
}

alias ttdownload {

  ;Syntax: /ttdownload <url> [destination_folder]

  if ($1 == $null) { tterror /ttdownload insufficient parameters }
  if ($left($1,7) != http://) { tterror /ttdownload invalid server }
  if ($2 != $null) {
    if (!$isdir($2-)) { .mkdir $2- }
    set %ttdownloadfolder $2- $+ $iif($left($2-,1) != \,\)
  }
  else { set %ttdownloadfolder $scriptdir }

  var %server = $gettok($1,2,47)
  if (%server == $null) { tterror /ttdownload invalid server }
  if ($numtok(%server,58) == 2) {
    if ($gettok(%server,2,58) !isnum 1-65536) { tterror /ttdownload invalid port }
    set %ttdownloadport $gettok(%server,2,58) | set %ttdownloadserver $gettok(%server,1,58)
  }
  else { set %ttdownloadport 80 | set %ttdownloadserver %server }

  if ($sock(ttdownload)) {
    sockclose ttdownload
    .signal -n ttdownload-canceled %ttdownloadfile
  }

  set %ttdownloadfile $nopath($1)
  set %ttdownloadurl http:// $+ %ttdownloadserver $+ / $+ $deltok($1,1-2,47)

  set %ttdownloadctime $ctime
  .timerttdownload 0 10 ttchecktimeout

  .signal -n ttdownload-start %ttdownloadfile
  sockopen ttdownload %ttdownloadserver %ttdownloadport
}

on *:sockopen:ttdownload:{
  if ($sockerr) { .signal -n ttdownload-sockerr %ttdownloadfile | return }
  .signal -n ttdownload-connected %ttdownloadfile

  var %file = $qt(%ttdownloadfolder $+ %ttdownloadfile)
  if ($script(%file)) { .unload -rs %file }
  if ($exists(%file)) { .remove %file }
  set %ttdownloadheader $false
  set %ttdownloadbr 0
  set %ttdownloadnotfound 0

  sockwrite -n $sockname GET %ttdownloadurl HTTP/1.1
  sockwrite -n $sockname Host: %ttdownloadserver
  sockwrite -n $sockname Connection: Close
  sockwrite -n $sockname $crlf
}

on *:sockread:ttdownload:{
  if ($sockerr) { .signal -n ttdownload-sockerr %ttdownloadfile | return }

  var %read
  var %file = $qt(%ttdownloadfolder $+ %ttdownloadfile)

  sockread %read

  if (!%ttdownloadheader) {
    if (*404 Not Found* iswm %Read) { set %ttdownloadnotfound 1 | sockclose $sockname | .signal -n ttdownload-notfound %ttdownloadfile | return }
    elseif (Content-Length:* iswm %read) { set %ttdownloadsize $gettok(%read,2,32) | .signal -n ttdownload-filesize %ttdownloadsize }
    elseif (%read == $null) { set %ttdownloadheader $true }
  }
  elseif (!%ttdownloadnotfound) {
    if (%read == $null) { inc %ttdownloadbr 2 | write %file $crlf }
    else { inc %ttdownloadbr $calc($len(%read) + 2) | write %file %read }
    var %progress = $round($calc((%ttdownloadbr / %ttdownloadsize) * 100),0)
    if (%ttdownloadprogress != %progress) { .signal -n ttdownload-progress %progress }
    if ($calc(%ttdownloadsize - %ttdownloadbr) <= 0) { sockclose $sockname | .signal -n ttdownload-finished %ttdownloadfile | return }
  }
}
